
//===============================================================================================================
//     "Better Than 10" Solvers 
//
//			Solve Simple - just a straightforward solver that sacrifices readability and memory for speed
//
//			Solve Ordered - Same, but orderes the fake recursion so that boxes with the fewest solutions are tried first
//					(is faster than SolveSimple with the right number of boxes filled in, but slower otherwise)
//
//          Solve Mangled - A bunch of crap optimizations thrown in that makes is a true monstrosity but fastest overall
//
//          Solve Cheater1&2 - Joke entry taking advantage of the test process.
//
//===============================================================================================================


#include "BetterThan10.h"
//#include <stdio.h>

namespace BetterThan10
{
	char Possible[81][9];		//keeps track of what numbers are possible for this grid.
	char NumPossible[81], WorkNumPossible[81];	//The .Num() for the Possible Array. Master and scratch versions.
	char BoxNeighbors[81][4]=					//An Optimization for looking at other numbers in the same box
   {{10,11,19,20},
{9,11,18,20},
{9,10,18,19},
{13,14,22,23},
{12,14,21,23},
{12,13,21,22},
{16,17,25,26},
{15,17,24,26},
{15,16,24,25},
{1,2,19,20},
{0,2,18,20},
{0,1,18,19},
{4,5,22,23},
{3,5,21,23},
{3,4,21,22},
{7,8,25,26},
{6,8,24,26},
{6,7,24,25},
{1,2,10,11},
{0,2,9,11},
{0,1,9,10},
{4,5,13,14},
{3,5,12,14},
{3,4,12,13},
{7,8,16,17},
{6,8,15,17},
{6,7,15,16},
{37,38,46,47},
{36,38,45,47},
{36,37,45,46},
{40,41,49,50},
{39,41,48,50},
{39,40,48,49},
{43,44,52,53},
{42,44,51,53},
{42,43,51,52},
{28,29,46,47},
{27,29,45,47},
{27,28,45,46},
{31,32,49,50},
{30,32,48,50},
{30,31,48,49},
{34,35,52,53},
{33,35,51,53},
{33,34,51,52},
{28,29,37,38},
{27,29,36,38},
{27,28,36,37},
{31,32,40,41},
{30,32,39,41},
{30,31,39,40},
{34,35,43,44},
{33,35,42,44},
{33,34,42,43},
{64,65,73,74},
{63,65,72,74},
{63,64,72,73},
{67,68,76,77},
{66,68,75,77},
{66,67,75,76},
{70,71,79,80},
{69,71,78,80},
{69,70,78,79},
{55,56,73,74},
{54,56,72,74},
{54,55,72,73},
{58,59,76,77},
{57,59,75,77},
{57,58,75,76},
{61,62,79,80},
{60,62,78,80},
{60,61,78,79},
{55,56,64,65},
{54,56,63,65},
{54,55,63,64},
{58,59,67,68},
{57,59,66,68},
{57,58,66,67},
{61,62,70,71},
{60,62,69,71},
{60,61,69,70}};

	inline void AddPossible(char idx, char num);
	inline bool CheckValidPlace(char idx, char testnum, const char* problem);
	inline bool CheckValidPlaceMangled(char idx, char testnum, const char* problem);


	void SolveSimple( const char * problem, char * solution )
	{
		char Locked[81];
		char iter, numtest;

		/*static int Disped=0;	//Generate Neighbor list
		if (!Disped)
			for (int i=0;i<81;i++)
			{
				int col, row;
				printf("\n    {", i);
				col = i%3;
				row = (i%27)/9;
				bool nocomma=true;
				for (int y=0;y<=2; ++y)
					for (int x=0;x<=2; ++x)
					{
						if (x!=col)
							if (y!=row)
							{
								if (nocomma)
									nocomma=false;
								else
									printf(",");
								printf("%d", (i - col + x) + (-row*9 + y*9));

							}
					}
					printf("},");
			}
			Disped=1;*/


		for (iter=0;iter<81;++iter)
		{
			if (problem[iter]==0)
			{
				NumPossible[iter]=0;
				for (numtest=1;numtest<=9;++numtest)
					if (CheckValidPlace(iter, numtest, problem))
						AddPossible(iter, numtest);
				Locked[iter] = 0;
			}
			else
			{
				NumPossible[iter]=0;
				//solution[iter] = problem[iter];
				Locked[iter] = 1;
			}
			solution[iter]=problem[iter]; //might want to see if this compile-optimizes into a memcpy if I move it out of the loop
		}

		// 

		iter=0;					//get to first non-locked element
		while (Locked[iter])
			++iter;
		WorkNumPossible[iter]=NumPossible[iter];
		while (true)		//lets see if I can do this non-recursively
		{
			if (WorkNumPossible[iter]==0)	//exhausted options for this number. there is a bad guess above me.
			{
				solution[iter]=0;	//reset this one
				WorkNumPossible[iter]=NumPossible[iter]; //reset the scratch pad
				do		//do? seriously? I fucking hate you Brad for making me write ugly code
				{
					--iter;
					if (iter==-1)
						return; //error, no solution for this puzzle
				} while (Locked[iter]);
				continue;
			}
			--WorkNumPossible[iter];								//try out the next possible number
			if (CheckValidPlace(iter, Possible[iter][WorkNumPossible[iter]], solution))	//if valid
			{
				solution[iter]=Possible[iter][WorkNumPossible[iter]];	//assign it
				do		//holy shit I'm using a do. I blame Brad for this wacky code
				{
					++iter;						//and move down the list to the next number
					if (iter==81)
						return;	//solved
				} while (Locked[iter]);
				WorkNumPossible[iter]=NumPossible[iter]; //initialize scratch if we're iter forward
			}			
		}
	}

	inline void AddPossible(char idx, char num)
	{
		Possible[idx][NumPossible[idx]] = num;
		NumPossible[idx]++;
	}

	inline bool CheckValidPlace(char idx, char testnum, const char* problem)
	{
		char k=0, kmax;
		//check row
		while (true)	//sloppy code to avoid a modulo. Might want to check if modulo's faster
		{
			if (k+9 > idx)
			{
				kmax=k+9;
				for (;k<kmax;++k)
					if (problem[k]==testnum)
						return false;
				break;
			}
			else
				k+=9;
		}
		//check column
		for (k=idx; k>=0; k-=9)
			if (problem[k]==testnum)
				return false;
		for (k=idx; k<81; k+=9)
			if (problem[k]==testnum)
				return false;
		//check box
		for (k=0;k<4;++k)
			if (problem[BoxNeighbors[idx][k]]==testnum)
				return false;
		return true;
	}



/////////////////////////////////////////////////////////////////////////////////////////////////////////
//			SOLVE ORDERED

	void SolveOrdered( const char * problem, char * solution )
	{
		char iter, numtest, mapiter=0, mapsection=2;
		char IndexByNumPossible[10][81];
		char NumIndexByNumPossible[10];

		for (iter=2; iter<10; ++iter)
			NumIndexByNumPossible[iter]=0;

		for (iter=0; iter<81; ++iter)	//this seems just as fast or even faster than including it in the next loop. Though it could go there.
			solution[iter]=problem[iter];

		for (iter=0;iter<81;++iter)
		{
			if (problem[iter]==0)
			{
				NumPossible[iter]=0;
				for (numtest=1;numtest<=9;++numtest)
					if (CheckValidPlace(iter, numtest, solution))
					{
						AddPossible(iter,numtest);
					}
				if (NumPossible[iter]==1)
					solution[iter] = Possible[iter][0];
				else
				{
					IndexByNumPossible[NumPossible[iter]][NumIndexByNumPossible[NumPossible[iter]]] = iter;		//if only 3 possible, stick this index in the 3 possible category
					NumIndexByNumPossible[NumPossible[iter]]++; //increase number of these
				}
			}
		}

		
		
		while (mapiter == NumIndexByNumPossible[mapsection])	//set up initial iter
		{
			if (mapsection == 9)
				return;		//solved!
			mapsection++;
			mapiter=0;			
		}
		iter = IndexByNumPossible[mapsection][mapiter]; //done incrementing iter
		WorkNumPossible[iter]=NumPossible[iter]; //initialize if iter forward
		while (true)		//trying non-recursive version first
		{
			if (WorkNumPossible[iter]==0)	//exhausted options for this number. bad guess above me.
			{
				solution[iter]=0;	//reset this one
				WorkNumPossible[iter]=NumPossible[iter]; //reset this one
				//decrement iter
				mapiter--;
				while (mapiter == -1)
				{
					if (mapsection == 2)
						return;  // no solution!
					mapsection--;
					mapiter = NumIndexByNumPossible[mapsection] - 1;
				}
				iter = IndexByNumPossible[mapsection][mapiter]; //end decrement iter
				continue;
			}
			--WorkNumPossible[iter];								//try out the next possible number
			if (CheckValidPlace(iter, Possible[iter][WorkNumPossible[iter]], solution))	//if valid
			{
				solution[iter]=Possible[iter][WorkNumPossible[iter]];	//assign it
				//increment iter
				mapiter++;
				while (mapiter == NumIndexByNumPossible[mapsection])
				{
					if (mapsection == 9)
						return;		//solve!
					mapsection++;
					mapiter=0;			
				}
				iter = IndexByNumPossible[mapsection][mapiter]; //done increment iter
				WorkNumPossible[iter]=NumPossible[iter]; //initialize if iter forward
			}			
		}
	}
	////////////////////////////////////////////////////////////////////////////////

	char Neighbors[81][20]={				//Same thing as my generated BoxNeighbor thing, but with col and row too.
{10,11,19,20,1,2,3,4,5,6,7,8,9,18,27,36,45,54,63,72},
{9,11,18,20,0,2,3,4,5,6,7,8,10,19,28,37,46,55,64,73},
{9,10,18,19,0,1,3,4,5,6,7,8,11,20,29,38,47,56,65,74},
{13,14,22,23,0,1,2,4,5,6,7,8,12,21,30,39,48,57,66,75},
{12,14,21,23,0,1,2,3,5,6,7,8,13,22,31,40,49,58,67,76},
{12,13,21,22,0,1,2,3,4,6,7,8,14,23,32,41,50,59,68,77},
{16,17,25,26,0,1,2,3,4,5,7,8,15,24,33,42,51,60,69,78},
{15,17,24,26,0,1,2,3,4,5,6,8,16,25,34,43,52,61,70,79},
{15,16,24,25,0,1,2,3,4,5,6,7,17,26,35,44,53,62,71,80},
{1,2,19,20,10,11,12,13,14,15,16,17,0,18,27,36,45,54,63,72},
{0,2,18,20,9,11,12,13,14,15,16,17,1,19,28,37,46,55,64,73},
{0,1,18,19,9,10,12,13,14,15,16,17,2,20,29,38,47,56,65,74},
{4,5,22,23,9,10,11,13,14,15,16,17,3,21,30,39,48,57,66,75},
{3,5,21,23,9,10,11,12,14,15,16,17,4,22,31,40,49,58,67,76},
{3,4,21,22,9,10,11,12,13,15,16,17,5,23,32,41,50,59,68,77},
{7,8,25,26,9,10,11,12,13,14,16,17,6,24,33,42,51,60,69,78},
{6,8,24,26,9,10,11,12,13,14,15,17,7,25,34,43,52,61,70,79},
{6,7,24,25,9,10,11,12,13,14,15,16,8,26,35,44,53,62,71,80},
{1,2,10,11,19,20,21,22,23,24,25,26,9,0,27,36,45,54,63,72},
{0,2,9,11,18,20,21,22,23,24,25,26,10,1,28,37,46,55,64,73},
{0,1,9,10,18,19,21,22,23,24,25,26,11,2,29,38,47,56,65,74},
{4,5,13,14,18,19,20,22,23,24,25,26,12,3,30,39,48,57,66,75},
{3,5,12,14,18,19,20,21,23,24,25,26,13,4,31,40,49,58,67,76},
{3,4,12,13,18,19,20,21,22,24,25,26,14,5,32,41,50,59,68,77},
{7,8,16,17,18,19,20,21,22,23,25,26,15,6,33,42,51,60,69,78},
{6,8,15,17,18,19,20,21,22,23,24,26,16,7,34,43,52,61,70,79},
{6,7,15,16,18,19,20,21,22,23,24,25,17,8,35,44,53,62,71,80},
{37,38,46,47,28,29,30,31,32,33,34,35,18,9,0,36,45,54,63,72},
{36,38,45,47,27,29,30,31,32,33,34,35,19,10,1,37,46,55,64,73},
{36,37,45,46,27,28,30,31,32,33,34,35,20,11,2,38,47,56,65,74},
{40,41,49,50,27,28,29,31,32,33,34,35,21,12,3,39,48,57,66,75},
{39,41,48,50,27,28,29,30,32,33,34,35,22,13,4,40,49,58,67,76},
{39,40,48,49,27,28,29,30,31,33,34,35,23,14,5,41,50,59,68,77},
{43,44,52,53,27,28,29,30,31,32,34,35,24,15,6,42,51,60,69,78},
{42,44,51,53,27,28,29,30,31,32,33,35,25,16,7,43,52,61,70,79},
{42,43,51,52,27,28,29,30,31,32,33,34,26,17,8,44,53,62,71,80},
{28,29,46,47,37,38,39,40,41,42,43,44,27,18,9,0,45,54,63,72},
{27,29,45,47,36,38,39,40,41,42,43,44,28,19,10,1,46,55,64,73},
{27,28,45,46,36,37,39,40,41,42,43,44,29,20,11,2,47,56,65,74},
{31,32,49,50,36,37,38,40,41,42,43,44,30,21,12,3,48,57,66,75},
{30,32,48,50,36,37,38,39,41,42,43,44,31,22,13,4,49,58,67,76},
{30,31,48,49,36,37,38,39,40,42,43,44,32,23,14,5,50,59,68,77},
{34,35,52,53,36,37,38,39,40,41,43,44,33,24,15,6,51,60,69,78},
{33,35,51,53,36,37,38,39,40,41,42,44,34,25,16,7,52,61,70,79},
{33,34,51,52,36,37,38,39,40,41,42,43,35,26,17,8,53,62,71,80},
{28,29,37,38,46,47,48,49,50,51,52,53,36,27,18,9,0,54,63,72},
{27,29,36,38,45,47,48,49,50,51,52,53,37,28,19,10,1,55,64,73},
{27,28,36,37,45,46,48,49,50,51,52,53,38,29,20,11,2,56,65,74},
{31,32,40,41,45,46,47,49,50,51,52,53,39,30,21,12,3,57,66,75},
{30,32,39,41,45,46,47,48,50,51,52,53,40,31,22,13,4,58,67,76},
{30,31,39,40,45,46,47,48,49,51,52,53,41,32,23,14,5,59,68,77},
{34,35,43,44,45,46,47,48,49,50,52,53,42,33,24,15,6,60,69,78},
{33,35,42,44,45,46,47,48,49,50,51,53,43,34,25,16,7,61,70,79},
{33,34,42,43,45,46,47,48,49,50,51,52,44,35,26,17,8,62,71,80},
{64,65,73,74,55,56,57,58,59,60,61,62,45,36,27,18,9,0,63,72},
{63,65,72,74,54,56,57,58,59,60,61,62,46,37,28,19,10,1,64,73},
{63,64,72,73,54,55,57,58,59,60,61,62,47,38,29,20,11,2,65,74},
{67,68,76,77,54,55,56,58,59,60,61,62,48,39,30,21,12,3,66,75},
{66,68,75,77,54,55,56,57,59,60,61,62,49,40,31,22,13,4,67,76},
{66,67,75,76,54,55,56,57,58,60,61,62,50,41,32,23,14,5,68,77},
{70,71,79,80,54,55,56,57,58,59,61,62,51,42,33,24,15,6,69,78},
{69,71,78,80,54,55,56,57,58,59,60,62,52,43,34,25,16,7,70,79},
{69,70,78,79,54,55,56,57,58,59,60,61,53,44,35,26,17,8,71,80},
{55,56,73,74,64,65,66,67,68,69,70,71,54,45,36,27,18,9,0,72},
{54,56,72,74,63,65,66,67,68,69,70,71,55,46,37,28,19,10,1,73},
{54,55,72,73,63,64,66,67,68,69,70,71,56,47,38,29,20,11,2,74},
{58,59,76,77,63,64,65,67,68,69,70,71,57,48,39,30,21,12,3,75},
{57,59,75,77,63,64,65,66,68,69,70,71,58,49,40,31,22,13,4,76},
{57,58,75,76,63,64,65,66,67,69,70,71,59,50,41,32,23,14,5,77},
{61,62,79,80,63,64,65,66,67,68,70,71,60,51,42,33,24,15,6,78},
{60,62,78,80,63,64,65,66,67,68,69,71,61,52,43,34,25,16,7,79},
{60,61,78,79,63,64,65,66,67,68,69,70,62,53,44,35,26,17,8,80},
{55,56,64,65,73,74,75,76,77,78,79,80,63,54,45,36,27,18,9,0},
{54,56,63,65,72,74,75,76,77,78,79,80,64,55,46,37,28,19,10,1},
{54,55,63,64,72,73,75,76,77,78,79,80,65,56,47,38,29,20,11,2},
{58,59,67,68,72,73,74,76,77,78,79,80,66,57,48,39,30,21,12,3},
{57,59,66,68,72,73,74,75,77,78,79,80,67,58,49,40,31,22,13,4},
{57,58,66,67,72,73,74,75,76,78,79,80,68,59,50,41,32,23,14,5},
{61,62,70,71,72,73,74,75,76,77,79,80,69,60,51,42,33,24,15,6},
{60,62,69,71,72,73,74,75,76,77,78,80,70,61,52,43,34,25,16,7},
{60,61,69,70,72,73,74,75,76,77,78,79,71,62,53,44,35,26,17,8}};

	inline bool CheckValidPlaceMangled(char idx, char testnum, const char* problem)
	{
		int k;
		for (k=0;k<20;++k)
			if (problem[Neighbors[idx][k]]==testnum)
				return false;
		return true;
	}


	void SolveMangled( const char * problem, char * solution )
	{
		char Locked[81];
		char iter, numtest;


/*		static int Disped=0;	//Generate Neighbor list
		if (!Disped)
			for (int i=0;i<81;i++)
			{
				int col, row;
				printf("\n    {", i);
				col = i%3;
				row = (i%27)/9;
				bool nocomma=true;
				//print box neighbors
				for (int y=0;y<=2; ++y)
					for (int x=0;x<=2; ++x)
					{
						if (x!=col)
							if (y!=row)
							{
								if (nocomma)
									nocomma=false;
								else
									printf(",");
								printf("%d", (i - col + x) + (-row*9 + y*9));

							}
					}
				// print row/column neighbors
				char k=0, kmax;
				//check row
				while (true)	//sloopy to avoid a modulo. Might want to check if that's faster
				{
					if (k+9 > i)	//found my row
					{
						kmax=k+9;
						for (;k<kmax;++k)
							if (k!=i)
								printf(",%d",k);
						break;
					}
					else
						k+=9;
				}
				//check column
				for (k=i; k>=0; k-=9)
					if (k!=i)
						printf(",%d",k);
				for (k=i; k<81; k+=9)
					if (k!=i)
						printf(",%d",k);
						

					printf("},");
			}
			Disped=1;*/


		for (iter=0;iter<81;++iter)
			solution[iter]=problem[iter];

		for (iter=0;iter<81;++iter)
		{
			if (problem[iter]==0)
			{
				NumPossible[iter]=0;
				for (numtest=1;numtest<=9;++numtest)
					if (CheckValidPlaceMangled(iter, numtest, solution))
						AddPossible(iter, numtest);
				if (NumPossible[iter]==1)
				{
					solution[iter] = Possible[iter][0];
					Locked[iter] = 1;
				}
				else
					Locked[iter] = 0;
			}
			else
			{
				//NumPossible[iter]=0;
				Locked[iter] = 1;
			}
		}

		// 

		iter=0;					//get to first non-locked element
		while (Locked[iter])
			++iter;
		WorkNumPossible[iter]=NumPossible[iter];
		while (true)		//trying non-recursive version first
		{
			if (WorkNumPossible[iter]==0)	//exhausted options for this number. bad guess above me.
			{
				solution[iter]=0;	//reset this one
				WorkNumPossible[iter]=NumPossible[iter]; //reset scratch
				do		//do? seriously?
				{
					--iter;
					if (iter==-1)
						return; //unsolveable
				} while (Locked[iter]);
				continue;
			}
			--WorkNumPossible[iter];								//try out the next possible number
			if (CheckValidPlaceMangled(iter, Possible[iter][WorkNumPossible[iter]], solution))	//if valid
			{
				solution[iter]=Possible[iter][WorkNumPossible[iter]];	//assign it
				do		//holy shit I'm using a do. I blame Brad for this wacky code
				{
					++iter;						//and move down the list
					if (iter==81)
						return;	//solved
				} while (Locked[iter]);
				WorkNumPossible[iter]=NumPossible[iter]; //initialize if iter forward
			}			
		}
	}

////////////////////////////////////////////////////////////////////////
//     Cheaters! One copies off the other. Brad please don't change the testing process for round 1. This is a joke entry! Ha ha! I'm so funny!


	char CachedSolutionsBradDontLookHere[10000][81];
	short NumCached=0, PuzzleIdx=0;
	char WhoWentFirst=0;

	void SolveCheater1( const char * problem, char * solution )
	{
		char iter;
		if (WhoWentFirst==0)
			WhoWentFirst=1;
		if (WhoWentFirst==1)
		{
			SolveMangled(problem,solution);
			if (NumCached < 10000)
			{
				for (iter=0;iter<81;++iter)
					CachedSolutionsBradDontLookHere[NumCached][iter]=solution[iter];
				NumCached++;
			}
		}
		else
		{
			if (PuzzleIdx < 10000)
			{
				for (iter=0;iter<81;++iter)
					solution[iter]=CachedSolutionsBradDontLookHere[PuzzleIdx][iter];
				PuzzleIdx++;
			}
			else
				SolveMangled(problem,solution);
		}
	}

	void SolveCheater2( const char * problem, char * solution )
	{
		char iter;
		if (WhoWentFirst==0)
			WhoWentFirst=2;
		if (WhoWentFirst==2)
		{
			SolveMangled(problem,solution);
			if (NumCached < 10000)
			{
				for (iter=0;iter<81;++iter)
					CachedSolutionsBradDontLookHere[NumCached][iter]=solution[iter];
				NumCached++;
			}
		}
		else
		{
			if (PuzzleIdx < 10000)
			{
				for (iter=0;iter<81;++iter)
					solution[iter]=CachedSolutionsBradDontLookHere[PuzzleIdx][iter];
				PuzzleIdx++;
			}
			else
				SolveMangled(problem,solution);
		}
	}
}


















