#ifndef BRAD_H
#define BRAD_H

// Brad Smith
// 5/10/2009

namespace Brad
{
	void ice_climbers( const char * problem, char * solution );
	// ice_climbers marches through the empty squares in the
	// grid recursively:
	//   1. Try a value (1 to 9) for this empty spot.
	//   2. If this value hasn't already been used in the
	//      row/column/box, recurse to 1.
	//   3. If the result of the recursion test produced a
	//      solution, return, notifying success to the parent call.
	//   4. If the result of the recursion test could not
	//      produce a solution, repeat from 1 with another value.
	//   5. If all values ended in falure, return,
	//      notifying failure to the parent.
	// A coule of optimization "tricks" were applied here,
	// of which the most effective was unrolling the inner loops.
	// These tricks are documented in the source, and their
	// are some defines you can play with if you want to see
	// how much of an impact they have.

	void ice_drillers( const char * problem, char * solution );
	// ice_drillers is a non-recursive version of ice_climbers.
	// Instead of storing the current branch in a call stack,
	// this program simply determines the last branch taken
	// from the puzzle's state. Otherwise it uses most of the same code.
	// I thought it was interesing how these two programs performed
	// almost identically; I was originally expecting ice_drillers
	// to outperform ice_climbers due to function call overhead, but
	// in this case that didn't seem to be much of a factor.
	// The bottleneck seems to be in the test_point function instead.
}

#endif BRAD_H
