#ifndef GENERATOR_H
#define GENERATOR_H

namespace Generator
{
	// random number generator, do not use before or during problem generation,
	// but it is free to use after.
	unsigned int rand9();

	// pass a number to seed the random number generator
	void seed_generator( unsigned int seed );

	// generates a sudoku problem
	void generate( char * problem );

	// returns true if the problem is solved
	bool solved( const char * problem, const char * solution );

	// for debugging, will print to the console
	void print( const char * sudoku );

	// prints two sudoku side by side
	void print2( const char * left, const char * right );
}

#endif // GENERATOR_H
