#ifndef BROCK_H
#define BROCK_H

#define BROCK_DEBUG		0
#define BROCK_PROFILE	0

/*
	Brock Heinz
	05/20/09

	I made the mistake of writing most of the code before actually trying to run it, and didn't have time to track down the bugs. 
	Right now, it only solves a small fraction of the puzzles. My original idea was to cache extra state information about the boards, 
	and then apply different solution strategies at each step based on their state. Since I haven't had time to work out the kinks with 
	just a basic brute-force solver, I didn't get to put in additional strategies. It probably didn't help that I did most of the 
	work between 10pm and 2am. :) 

	I'd like to try out different general purpose iterative AI-type solvers that just work based on the board state, rather than 
	writing a bunch of custom rules for Sudoku. I assume that strategies which exploit the rules of sudoku would be much
	faster, but less personally interesting. 

	One thing I noticed while playing around with a purely random solver was that the program was spending a ton of time 
	fetching random numbers. Any strategies that lean heavily on some type of weighted random selection would benefit from
	a custom random number generator. 

	Since this doesn't work very well at the moment, I'm not 100% sure what parts are good to pillage for other people, 
	but some of the state caching stuff might be useful in some circumstances. 

*/

namespace Brock
{
	void find_solution( const char * problem, char * solution );
}

#endif // BROCK_H
